%global	ruby_sitelib	%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%global	ruby_sitearch	%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")

%global	gemdir		%(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global	gemname	vte
%global	geminstdir	%{gemdir}/gems/%{gemname}-%{version}

%global	glibminver	0.90.7
%global	obsoleteevr	0.90.7-1.999

%global	rubyabi	1.8

Summary:	Ruby binding of vte
Name:		rubygem-%{gemname}
Version:	0.90.8
Release:	2%{?dist}
Group:		Development/Languages
# from README
License:	LGPLv2
URL:		http://ruby-gnome2.sourceforge.jp/
Source0:	http://rubygems.org/gems/%{gemname}-%{version}.gem

BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	rubygem-glib2-devel >= %{glibminver}
BuildRequires:	rubygem-gtk2-devel
BuildRequires:	ruby-devel
BuildRequires:	vte-devel
Requires:	ruby(abi) = %{rubyabi}
Requires:	rubygem(gtk2)
Provides:	rubygem(%{gemname}) = %{version}

%description
Ruby/VTE is a Ruby binding of VTE

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	-n ruby-%{gemname}
Summary:	Non-Gem support package for %{gemname}
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
# Requires for corresponsing non-gem rpms
Requires:	ruby(gtk2)
Provides:	ruby(%{gemname}) = %{version}-%{release}

%description	-n ruby-%{gemname}
This package provides non-Gem support for %{gemname}.

%package	devel
Summary:	Ruby/VTE development environment
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
# Obsoletes / Provides
# ruby(%%{gemname}-devel) Provides is for compatibility
Obsoletes:	ruby-%{gemname}-devel < %{obsoleteevr}
Provides:	ruby-%{gemname}-devel = %{version}-%{release}
Provides:	ruby(%{gemname}-devel) = %{version}-%{release}

%description devel
Header files and libraries for building a extension library for the
rubygem-%{gemname}

%prep
%setup -q -c -T

mkdir -p .%{gemdir}

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
# Unset pkg-config-dir until .depend files bug is fixed
%if 0
export CONFIGURE_ARGS="$CONFIGURE_ARGS --with-pkg-config-dir=$(pwd)%{_libdir}/pkgconfig"
%endif
gem install \
	-V \
	--local \
	--install-dir .%{gemdir} \
	--force \
	--rdoc \
	%{SOURCE0}

find . -name \*.gem | xargs chmod 0644

pushd .%{geminstdir}

# Fix wrong shebang
#grep -rl /usr/local/bin sample | \
#	xargs sed -i -e 's|/usr/local/bin|/usr/bin|'

# Kill shebang
grep -rl '#!.*/usr/bin' sample | \
	xargs sed -i -e '\@#![ ]*/usr/bin@d'
find sample/ -name \*.rb | xargs chmod 0644
popd

%build
# Move C extension library to some private directory
pushd .%{geminstdir}
mkdir lib/ruby-gnome2
mv lib/%{gemname}.so lib/ruby-gnome2/
grep -rl '%{gemname}.so' . | \
	xargs sed -i \
		-e "\@require@s|'%{gemname}.so'|'ruby-gnome2/%{gemname}.so'|" \
		-e '\@require@s|"%{gemname}.so"|"ruby-gnome2/%{gemname}.so"|'

popd
# For now, install .pc files manually to the expected directory
mkdir -p .%{_libdir}/pkgconfig
install -cpm 644 .%{geminstdir}/ext/*/ruby-%{gemname}.pc \
	.%{_libdir}/pkgconfig/

%install
# Once copy all
mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* \
	%{buildroot}%{gemdir}/

pushd %{buildroot}
# move header files, C extension files to the correct directory
mkdir -p .%{ruby_sitearch}/ruby-gnome2/
# mv .%%{geminstdir}/lib/*.h .%%{ruby_sitearch}/
mv .%{geminstdir}/lib/ruby-gnome2/%{gemname}.so .%{ruby_sitearch}/ruby-gnome2/
popd

# move pkgconfig file
mkdir %{buildroot}%{_libdir}/pkgconfig
install -cpm 644 ./%{_libdir}/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig/


# Cleanups
pushd %{buildroot}
rm -rf .%{geminstdir}/ext/
rm -f .%{geminstdir}/extconf.rb
popd

# The following method is completely copied from rubygem-gettext
# spec file
#
# Create symlinks
##
## Note that before switching to gem %%{ruby_sitelib}/%%{gemname}
## already existed as a directory, so this cannot be replaced
## by symlink (cpio fails)
## Similarly, all directories under %%{ruby_sitelib} cannot be
## replaced by symlink
#

create_symlink_rec(){

ORIGBASEDIR=$1
TARGETBASEDIR=$2

## First calculate relative path of ORIGBASEDIR 
## from TARGETBASEDIR
TMPDIR=$TARGETBASEDIR
BACKDIR=
DOWNDIR=
num=0
nnum=0
while true
do
	num=$((num+1))
	TMPDIR=$(echo $TMPDIR | sed -e 's|/[^/][^/]*$||')
	DOWNDIR=$(echo $ORIGBASEDIR | sed -e "s|^$TMPDIR||")
	if [ x$DOWNDIR != x$ORIGBASEDIR ]
	then
		nnum=0
		while [ $nnum -lt $num ]
		do
			BACKDIR="../$BACKDIR"
			nnum=$((nnum+1))
		done
		break
	fi
done

RELBASEDIR=$( echo $BACKDIR/$DOWNDIR | sed -e 's|//*|/|g' )

## Next actually create symlink
pushd %{buildroot}/$ORIGBASEDIR
find . -type f | while read f
do
	DIRNAME=$(dirname $f)
	BACK2DIR=$(echo $DIRNAME | sed -e 's|/[^/][^/]*|/..|g')
	mkdir -p %{buildroot}${TARGETBASEDIR}/$DIRNAME
	LNNAME=$(echo $BACK2DIR/$RELBASEDIR/$f | \
		sed -e 's|^\./||' | sed -e 's|//|/|g' | \
		sed -e 's|/\./|/|' )
	ln -s -f $LNNAME %{buildroot}${TARGETBASEDIR}/$f
done
popd

}

create_symlink_rec %{geminstdir}/lib %{ruby_sitelib}

%check
# Currently no testsuite available

%files
%defattr(-,root,root,-)
%dir	%{geminstdir}
%dir	%{geminstdir}/lib/

%doc	%{geminstdir}/[A-Z]*
%exclude	%{geminstdir}/Rakefile

%{geminstdir}/lib/%{gemname}.rb
# %%ruby_sitearch/ruby-gnome2 is owned by rubygem-glib2
%{ruby_sitearch}/ruby-gnome2/%{gemname}.so

%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files	-n ruby-%{gemname}
%defattr(-,root,root,-)
%{ruby_sitelib}/*.rb

%files	devel
%defattr(-,root,root,-)
%{_libdir}/pkgconfig/ruby-%{gemname}.pc

%files	doc
%defattr(-,root,root,-)
%{gemdir}/doc/%{gemname}-%{version}
%{geminstdir}/Rakefile
%{geminstdir}/sample/

%changelog
* Sun Mar 20 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.8-2
- Some cleanups

* Thu Mar 10 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.8-1
- 0.90.8

* Sat Feb 19 2011 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.7-2
- Initial package
